<?php

class Insign_Swisspost_Block_Adminhtml_Barcode_Grid extends Mage_Adminhtml_Block_Widget_Grid
{

    public function __construct()
    {
        parent::__construct();
        $this->setId('barcodeGrid');
        $this->setDefaultSort('entity_id');
        $this->setDefaultDir('DESC');
        $this->setSaveParametersInSession(true);
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getResourceModel('insign_swisspost/barcode_collection')->getCollectionWithShipment();
        $this->setCollection($collection);
        return parent::_prepareCollection();
    }

    protected function _prepareColumns()
    {
        $this->addColumn('entity_id', array(
            'header' => Mage::helper('insign_swisspost')->__('Barcode Id'),
            'align' => 'left',
            'width' => '50px',
            'index' => 'entity_id',
        ));

        $this->addColumn('shipment_increment_id', array(
            'header' => Mage::helper('insign_swisspost')->__('Shipment Id'),
            'align' => 'left',
            'width' => '50px',
            'index' => 'shipment_increment_id',
            'renderer'  => 'Insign_Swisspost_Block_Adminhtml_Barcode_Renderer_OrderAction',
        ));


        $this->addColumn('order_increment_id', array(
            'header' => Mage::helper('insign_swisspost')->__('Order Id'),
            'align' => 'left',
            'width' => '50px',
            'index' => 'order_increment_id',
            'renderer'  => 'Insign_Swisspost_Block_Adminhtml_Barcode_Renderer_ShipmentAction',
        ));
        $this->addColumn('action',
            array(
                'header'    =>  Mage::helper('insign_swisspost')->__('Actions'),
                'width'     => '100',
                'type'      => 'action',
                'getter'    => 'getId',
                'actions'   => array(
                    array(
                        'caption'   => Mage::helper('insign_swisspost')->__('Print'),
                        'url'       => array('base'=> '*/*/print'),
                        'field'     => 'id',
                        'target'=>'_blank'
                    )
                ),
                'filter'    => false,
                'sortable'  => false,
            ));
        $this->addColumn('created_at', array(
            'header' => Mage::helper('insign_swisspost')->__('Barcode Created At'),
            'filter'    => false,
            'sortable'  => false,
            'width'     => '100',
            'align' => 'right',
            'index' => 'created_at',
        ));

        return parent::_prepareColumns();
    }

}
