<?php
class Insign_Swisspost_Block_Adminhtml_Sales_Order_Shipment_Barcode extends Mage_Adminhtml_Block_Template {

    /**
     * Retrieve shipment model instance
     *
     * @return Mage_Sales_Model_Order_Shipment
     */
    public function getShipment()
    {
        return Mage::registry('current_shipment');
    }

    /**
     * Retrieve invoice order
     *
     * @return Mage_Sales_Model_Order
     */
    public function getOrder()
    {
        return $this->getShipment()->getOrder();
    }

    public function getBarcodeList()
    {
        $shipmentId = (int) $this->getShipment()->getId();
        return Mage::getResourceModel('insign_swisspost/barcode_collection')
            ->addFieldToFilter('shipment_id', $shipmentId);
    }

    public function getPrintUrl($file, $id)
    {
        $file = Mage::getModel('insign_swisspost/config')->getFullBarcodePathByFileName($file);
        if(!$file || !$id) {
            return false;
        }
        return Mage::helper("adminhtml")->getUrl("swisspost/adminhtml_barcode/print", array('id'=>$id));

    }

    public function getDownloadUrl($file, $id)
    {
        $file = Mage::getModel('insign_swisspost/config')->getFullBarcodePathByFileName($file);
        if(!$file || !$id) {
            return false;
        }
        return Mage::helper("adminhtml")->getUrl("swisspost/adminhtml_barcode/download", array('id'=>$id));
    }

}
