<?php

class Insign_Swisspost_Block_System_Config_Source_BasicServices
    extends Mage_Adminhtml_Block_System_Config_Form_Field_Array_Abstract
{
    public function _prepareToRender()
    {
        $this->addColumn('shipping_method', [
            'label' => Mage::helper('insign_swisspost')->__('Shipping Method Code'),
            'style' => 'width:100px',
            'renderer' => $this->_getRenderer(),
        ]);
        $this->addColumn('swiss_post_dlc', [
            'label' => Mage::helper('insign_swisspost')->__('Service Code'),
            'style' => 'width:100px',
            'renderer' => $this->_getDlcRenderer(),
        ]);

        $this->_addAfter = false;
        $this->_addButtonLabel = Mage::helper('insign_swisspost')->__('Add');
    }


    protected function  _getDlcRenderer()
    {
        if (!$this->_itemDlcRenderer) {
            $this->_itemDlcRenderer = $this->getLayout()->createBlock(
                'insign_swisspost/system_config_form_field_postDlcProvider', '',
                ['is_render_to_js_template' => true]
            );
        }
        return $this->_itemDlcRenderer;
    }
    protected function  _getRenderer()
    {
        if (!$this->_itemRenderer) {
            $this->_itemRenderer = $this->getLayout()->createBlock(
                'insign_swisspost/system_config_form_field_shippingMethodsProvider', '',
                ['is_render_to_js_template' => true]
            );
        }
        return $this->_itemRenderer;
    }

    protected function _prepareArrayRow(Varien_Object $row)
    {
        $row->setData(
            'option_extra_attr_' .$this->_getRenderer()
                ->calcOptionHash($row->getData('shipping_method')),
            'selected="selected"'
        );
        $row->setData(
            'option_extra_attr_' .$this->_getDlcRenderer()
                ->calcOptionHash($row->getData('swiss_post_dlc')),
            'selected="selected"'
        );
    }
}
