<?php

class Insign_Swisspost_Helper_Data extends Mage_Core_Helper_Abstract
{
    public function getShippingAddressPostStatus($order)
    {

        $shippingAddress = $order->getShippingAddress();
        if(!$shippingAddress->getPostAddressStatus()) {
            return false;
        }
        $type = 'notice-msg';
        $msg = 'An error occurred during the validation of the delivery address';
        switch ($shippingAddress->getPostAddressStatus()) {
            case 'DOMICILE_CERTIFIED':
            case 'CERTIFIED':
                $type = 'success-msg';
                $msg = 'The delivery address was successfully validated.';
                break;
            case 'VALID':
            case 'USABLE':
            case 'FIXED':
                $type = 'note-msg';
                $msg = 'The delivery address is valid but could not be verified.';
                break;
            case 'UNUSABLE':
            case 'COMPROMISED':
                $type = 'notice-msg';
                $msg = 'The validation of the delivery address has shown that it is invalid.';
                break;
        }
        return ['type'=>$type, 'msg'=>$msg];
    }

    /**
     * @return array[]
     */
    public function getDlcOptions()
    {
        return [
            ['value' => 'ECO', 'label' => $this->__('PostPac Economy')],
            ['value' => 'PRI', 'label' => $this->__('PostPac Priority')],
            ['value' => 'SP,ECO', 'label' => $this->__('Bulky goods Economy')],
            ['value' => 'SP,PRI', 'label' => $this->__('Bulky goods Priority')],
            ['value' => 'SEM', 'label' => $this->__('Swiss-Express "Moon"')]
        ];
    }

}
