<?php
class Insign_Swisspost_Model_AdminObserver {

    public function getSalesOrderViewInfo(Varien_Event_Observer $observer) {
        $block = $observer->getBlock();
        $blockNameInLayout = $block->getNameInLayout();
        if (($blockNameInLayout == 'order_tab_info' || $blockNameInLayout == 'order_info' )  && ($child = $block->getChild('swisspost.order.info.custom.block'))) {
            $transport = $observer->getTransport();
            if ($transport) {
                $html = $transport->getHtml();
                $html = $child->toHtml().$html;
                $transport->setHtml($html);
            }
        }
        if (($blockNameInLayout == 'form') && ($child = $block->getChild('swisspost.shipment.info.custom.block'))) {
            $transport = $observer->getTransport();
            if ($transport) {
                $html = $transport->getHtml();
                $html .= $child->toHtml();
                $transport->setHtml($html);
            }
        }

    }

    public function generateBarcode(Varien_Event_Observer $observer) {
        $shipment = $observer->getEvent()->getShipment();
        if ($shipmentId = $shipment->getEntityId()) {
            $barcode = Mage::getModel('insign_swisspost/barcode')->getCollection()
                ->addFieldToFilter('shipment_id', $shipmentId)
                ->getFirstItem();

            if (!$barcode->getEntityId()) {
                try {
                    Mage::getModel('insign_swisspost/barcodeProvider')->createBarcode($shipment);
                } catch (Exception $e) {
                    Mage::getModel('insign_swisspost/config')->log($e->getMessage(), Zend_Log::ERR);
                }
            }
        }
    }
    public function getSalesShipmentViewInfo(Varien_Event_Observer $observer) {
        $block = $observer->getEvent()->getBlock();
        if ($block instanceof Mage_Adminhtml_Block_Sales_Order_Shipment_View) {
            $shipmentId = $block->getShipment()->getId();
            $url = Mage::helper("adminhtml")->getUrl("swisspost/adminhtml_barcode/createbarcode/", ['shipment_id'=>$shipmentId]);
            $message = Mage::helper('insign_swisspost')->__('Are you sure you want to create new Barcode?');
            $block->addButton('create_new_barcode_button', [
                'label'     => Mage::helper('insign_swisspost')->__('Create New Barcode'),
                'onclick'   => "confirmSetLocation('{$message}', '{$url}')",
                'class'     => 'go'
            ]);
        }

    }
}
