<?php

class Insign_Swisspost_Model_Autocomplete
{
    const AUTOCOMPLETE_TYPE_DOMICILE = 'DOMICILE';
    const AUTOCOMPLETE_TYPE_POSTBOX = 'POSTBOX';

    /**
     * @param $zipCity
     * @return array|mixed
     * @throws Mage_Core_Exception
     * @throws Zend_Http_Client_Exception
     * @throws Zend_Json_Exception
     */
    public function zipCity($zipCity)
    {
        $rest = Mage::getSingleton('insign_swisspost/rest');
        $config = $rest->getConfig();

        $endPointUrl = $config->getAddressAutocompleteZipEndpoint();
        $tokenScope = $config->getAutocompleteScope();
        $options =[
            'type' => self::AUTOCOMPLETE_TYPE_DOMICILE,
            'zipCity' => $zipCity
        ];
        $data = $rest->getClient()->authenticatedRequest(Zend_Http_Client::GET, $endPointUrl, $options, $tokenScope);
        $response =  Zend_Json::decode($data->getBody());
        return $response['zips'] ?? [];
    }

    /**
     * @param string $streetName
     * @param string $zip
     * @throws Mage_Core_Exception
     * @throws Zend_Http_Client_Exception
     * @throws Zend_Json_Exception
     */
    public function street(string $streetName, string $zip = '')
    {
        $rest = Mage::getSingleton('insign_swisspost/rest');
        $config = $rest->getConfig();

        $endPointUrl = $config->getAddressAutocompleteStreetEndpoint();
        $tokenScope = $config->getAutocompleteScope();
        $options =[
            'name' => $streetName
        ];
        $options = ($zip !== '') ? array_merge($options, ['zip' => $zip]) : $options;
        $data = $rest->getClient()->authenticatedRequest(Zend_Http_Client::GET, $endPointUrl, $options, $tokenScope);
        $response =  Zend_Json::decode($data->getBody());
        return $response['streets'] ?? [];
    }

}
