<?php

class Insign_Swisspost_Model_Resource_Barcode_Collection extends Mage_Core_Model_Resource_Db_Collection_Abstract
{
    public function _construct()
    {
        $this->_init('insign_swisspost/barcode');
    }

    /**
     * @return int
     */
    public function getLastItemId()
    {
        $id = (int) $this->setOrder('entity_id', 'DESC')
            ->getFirstItem()->getId();
        return $id + 1;
    }

    public function getCollectionWithShipment()
    {
     $this->getSelect()
           ->joinLeft(
               ['shipment_table' => 'sales_flat_shipment'],
               'main_table.shipment_id = shipment_table.entity_id',
               ['shipment_increment_id'=>'shipment_table.increment_id', 'order_id']
           )
           ->joinLeft(
               ['order_table' => 'sales_flat_order'],
               'shipment_table.order_id = order_table.entity_id',
               ['order_increment_id'=>'order_table.increment_id']
           );
     $this->addFilterToMap('order_increment_id',  'order_table.increment_id');
     $this->addFilterToMap('shipment_increment_id',  'shipment_table.increment_id');
     //$d = $this->getSelect()->__toString();
     return $this;
    }
}
