<?php

/**
 * Token collection resource model
 * @package     Insign_Swisspost
 */
class Insign_Swisspost_Model_Resource_Token_Collection extends Mage_Core_Model_Resource_Db_Collection_Abstract
{
    protected $_joinedFields = array();

    /**
     * constructor
     * @access public
     * @return void
     */
    protected function _construct()
    {
        parent::_construct();
        $this->_init('insign_swisspost/token');
    }

    /**
     * @param string $scope
     * @return false|Varien_Object
     */
    public function getAccessToken(string $scope)
    {
        $date = new DateTime();
        $expireId = $date->getTimestamp();
        $item =  $this->addFieldToFilter('scope', $scope)
            ->addFieldToFilter('expire_in', ['gt' => $expireId])
            ->getFirstItem();
        if($item->getId()) {
            return $item->getToken();
        }
        return false;
    }

    /**
     * @param string $scope
     * @return false|Varien_Object
     */
    public function getAccessTokenByScope(string $scope)
    {
        $item = $this->addFieldToFilter('scope', $scope)
            ->getFirstItem();
        if($item->getId()) {
            return $item;
        }
        return false;
    }
}
