<?php

/**
 * Token model
 * @package     Insign_Swisspost
 */
class Insign_Swisspost_Model_Token extends Mage_Core_Model_Abstract
{
    /**
     * Entity code.
     * Can be used as part of method name for entity processing
     */
    const ENTITY    = 'insign_swisspost_token';
    const CACHE_TAG = 'insign_swisspost_token';

    /**
     * Prefix of model events names
     * @var string
     */
    protected $_eventPrefix = 'insign_swisspost_token';

    /**
     * Parameter name in event
     * @var string
     */
    protected $_eventObject = 'token';

    /**
     * constructor
     * @access public
     * @return void
     */
    public function _construct()
    {
        parent::_construct();
        $this->_init('insign_swisspost/token');
    }

    /**
     * before save token
     * @access protected
     * @return Insign_Swisspost_Model_Token
     */
    protected function _beforeSave()
    {
        parent::_beforeSave();
        $now = Mage::getSingleton('core/date')->gmtDate();
        if ($this->isObjectNew()) {
            $this->setCreatedAt($now);
        }
        $this->setUpdatedAt($now);
        return $this;
    }

    /**
     * save token relation
     * @access public
     * @return Insign_Swisspost_Model_Token
     */
    protected function _afterSave()
    {
        return parent::_afterSave();
    }
    
}
