<?php


class Insign_Swisspost_AddressController extends Mage_Core_Controller_Front_Action
{

    public function validateAction()
    {
        if ($this->getRequest()->isAjax()){
            $address = $this->getRequest()->getParams();
            if(isset($address['billing'])) {
                $address = $address['billing'];
            } elseif(isset($address['shipping'])) {
                $address = $address['shipping'];
            } else {
                return false;
            }
            $result = ['status'=>'emtpy', 'msg' => 'error'];
            try {
                $quality = Mage::getSingleton('insign_swisspost/addressValidator')->validate($address);
                if($quality) {
                    Mage::getSingleton('checkout/cart')->getQuote()->setPostAddressStatus($quality)->save();
                    $result = ['status'=>'ok', 'quality' => $quality];
                }
            } catch (\Exception $e) {
                $result['$msg'] = $e->getMessage();
            }
            $this->getResponse()->clearHeaders()->setHeader('Content-type','application/json',true);
            $this->getResponse()->setBody(json_encode($result));
        }
    }
    public function customerAddressAction()
    {
        $result = ['status'=>'emtpy', 'msg' => 'error'];
        if(Mage::getSingleton('customer/session')->isLoggedIn()){
            $addressId = $this->getRequest()->getParam('id');
            $customerAddress = Mage::getModel('customer/address')->load($addressId);
            $address = $customerAddress->toArray();
            try {
                $quality = Mage::getSingleton('insign_swisspost/addressValidator')->validate($address);
                if($quality) {
                    $customerAddress->setPostAddressStatus($quality)->save();
                    $result = ['status'=>'ok', 'quality' => $quality];
                }
            } catch (\Exception $e) {
                $result['$msg'] = $e->getMessage();
            }
            $this->getResponse()->clearHeaders()->setHeader('Content-type','application/json',true);
            return $this->getResponse()->setBody(json_encode($result));
        }
    }
}
