<?php


class Insign_Swisspost_AutocompleteController extends Mage_Core_Controller_Front_Action
{

    public function zipAction()
    {
        $zipCity = $this->getRequest()->getParam('zipCity');
        try {
            $zips = Mage::getSingleton('insign_swisspost/autocomplete')->zipCity($zipCity);
            if(!empty($zips)) {
                $zips =  array_map(function ($zip) {
                    return ['city' => $zip['city27'], 'zip' => $zip['zip'], 'label' => $zip['zip'] . ' ' . $zip['city27'], 'value' => $zip['zip'] . ' ' . $zip['city27']];
                }, $zips);
            }
        } catch (\Exception $e) {
            $zips = [];
        }
        $this->getResponse()->clearHeaders()->setHeader('Content-type','application/json',true);
        $this->getResponse()->setBody(json_encode($zips));
        if ($this->getRequest()->isAjax()){

        }
    }

    public function streetAction()
    {
        $zip = $this->getRequest()->getParam('zip');
        $streetName = $this->getRequest()->getParam('streetname');
        $streets = [];
        try {
            $streets = Mage::getSingleton('insign_swisspost/autocomplete')->street($streetName, $zip);
            if(!empty($streets)) {
                $streets =  array_map(function ($street) {
                    return ['street' => $street,  'label' => $street, 'value' => $street];
                }, $streets);
            }
        } catch (\Exception $e) {
            $streets = [];
        }
        $this->getResponse()->clearHeaders()->setHeader('Content-type','application/json',false);
        //$this->getResponse()->setBody(json_encode($streets));
        $this->getResponse()->setBody(Mage::helper('core')->jsonEncode($streets));
    }
}
